#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		daemon		sshd
#-----------------------------------------------------------------------------
Name		:	openssh
Version		:	9.4p1
Release		:	14.4.0.0%{?dist}
Summary		:	An open source implementation of SSH protocol versions 1 and 2
Group		:	Applications/Internet

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	BS
URL		:	http://www.openssh.com/portable.html

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	pam-devel
BuildRequires	:	openssl-devel

#-----------------------------------------------------------------------------
%description
SSH (Secure SHell) is a program for logging into and executing
commands on a remote machine. SSH is intended to replace rlogin and
rsh, and to provide secure encrypted communications between two
untrusted hosts over an insecure network. X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's version of the last free version of SSH, bringing
it up to date in terms of security and features.

This package includes the core files necessary for the OpenSSH server mode.

#-----------------------------------------------------------------------------
%files 
%defattr(-,root,root,-)
%doc README LICENCE CREDITS
%{_bindir}/ssh-add
%{_bindir}/ssh-agent
%{_bindir}/ssh-keygen
%{_bindir}/ssh-keyscan
%{_mandir}/man1/ssh-*.1.gz

#=============================================================================
%package clients

Summary		:	openssh client components

Requires	:	openssh = %{version}-%{release}

%description clients
This package include the openssh clients part.

#-----------------------------------------------------------------------------
%files clients
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}/ssh_config
%{_bindir}/ssh
%{_bindir}/scp
%{_bindir}/sftp
%{_mandir}/man1/ssh.1.gz
%{_mandir}/man1/scp.1.gz
%{_mandir}/man1/sftp.1.gz
%{_mandir}/man5/ssh_config.5.gz
%{_mandir}/man8/ssh-sk-helper.8.gz

#=============================================================================
%package server

Summary		:	openssh server components

Requires	:	/usr/sbin/useradd, /usr/sbin/userdel
Requires	:	/usr/sbin/groupadd, /usr/sbin/groupdel
Requires	:	lfs-bootscripts
Requires	:	chkconfig
Requires	:	openssh = %{version}-%{release}

%description server
This package include the openssh server part.

#-----------------------------------------------------------------------------
%files server
%defattr(-,root,root,-)
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{daemon}
%dir %attr(0711,root,root) %{_var}/lib/%{daemon}
%config(noreplace) %{_sysconfdir}/%{name}/sshd_config
%config(noreplace) %{_sysconfdir}/%{name}/sshd_config.d/*
%config(noreplace) %{_sysconfdir}/pam.d/%{daemon}
%{_sysconfdir}/%{name}/moduli
%{_sbindir}/sshd
%{_libexecdir}/%{name}
%{_mandir}/man5/moduli.5.gz
%{_mandir}/man5/sshd_config.5.gz
%{_mandir}/man8/sftp-server.8.gz
%{_mandir}/man8/ssh-keysign.8.gz
%{_mandir}/man8/ssh-pkcs11-helper.8.gz
%{_mandir}/man8/sshd.8.gz

#-----------------------------------------------------------------------------
%pre server
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{name}

  /usr/sbin/useradd 				\
	-r					\
	-c "Privilege-separated SSH"		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{name}				\
	-s /sbin/nologin			\
	-d %{_var}/privsep/%{daemon}		\
	%{daemon}
  fi

#-----------------------------------------------------------------------------
#after upgrade or remove
%preun server
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{daemon} stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{daemon}
  /usr/sbin/userdel %{daemon}
  /usr/sbin/groupdel %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#-----------------------------------------------------------------------------
%post server
/sbin/chkconfig --add %{daemon}
%{_sysconfdir}/rc.d/init.d/%{daemon} condrestart > /dev/null 2>&1 || :

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

tar xf %{SOURCE1}

#autoreconf -vif, problem avec OpenSSL 1.1.0i
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}/%{name}		\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}/%{name}		\
        --sysconfdir=%{_sysconfdir}/%{name}		\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--with-md5-passwords 				\
	--with-xauth=%{_bindir}/xauth			\
	--with-pam					\
	--with-privsep-path=%{_var}/lib/%{daemon}	\
	--with-privsep-user=%{daemon}			\
	--with-ipaddr-display				\
  	--with-pid-dir=/run				\
	--with-4in6					\
	--disable-strip					\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

#installing openssh starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 						\
	%{name}-ok_addon/%{daemon}			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#installing openssh pam limitation
%{__mkdir_p} %{buildroot}%{_sysconfdir}/pam.d
%{__cp} -a 						\
	%{name}-ok_addon/%{daemon}.pam			\
	%{buildroot}%{_sysconfdir}/pam.d/%{daemon}

#Allowing specific Osukiss configuration
(
echo "#---------------------------------------"
echo "#adding sub diretory directive"
echo "Include %{_sysconfdir}/%{name}/%{daemon}_config.d/*.conf"
echo "#---------------------------------------"
) >> %{buildroot}%{_sysconfdir}/%{name}/sshd_config
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}/sshd_config.d
%{__cp} -a 						\
	%{name}-ok_addon/50-osukiss.conf 		\
	%{buildroot}%{_sysconfdir}/%{name}/sshd_config.d/

#-----------------------------------------------------------------------------
%changelog
